#!/bin/sh


FILE="$1"
RES_FILE="$2"
#EXP="TOCSY,COSY,HNCA,HNCO,HNCOCA,HNCACO,CBCACONH,HBHACONH,HNCACB,CBCANH,HNCAHA,HNCOCAHA"
#EXP="TOCSY,HNCACO"
EXP="HNCACO,HBHACONH,CBCANH"
RESCUE2="./rescue2_static"
BMRB_STATS="./BMRB_stats_static"
BMRB_DIR="/serv/DATABASE/BMRB/"
FILE2=`echo $FILE | awk -F/ '{print $NF}'`
#RES_FILE="./RESULTS/${FILE2}.res"
ERR_FILE="./RESULTS/${FILE2}.err"
EXP_FILE="./RESULTS/${FILE2}.exp"
NUC_FILE="./RESULTS/${FILE2}.nuc"
XML_FILE="./RESULTS/${FILE2}.xml"

################################################################################
# Translate file input into XML for RESCUE2 and
# filter the input ... users always do what you do not expect :D
#
./spin_systems_to_xml < "$FILE" > "$XML_FILE"

################################################################################
# Translate user NMR experiments to a set of nuclei
#
touch $EXP_FILE;
echo "$EXP" | tr ',' '\n' > "$EXP_FILE"
rm -f "$NUC_FILE"
touch $NUC_FILE;
for exp in `cat $EXP_FILE`; do
	grep "^${exp}:" NMR_experiments.txt | cut -d ':' -f 2 | tr '\n' '|' >> "$NUC_FILE"
done
size=`cat $NUC_FILE | wc -c`
size=`echo "$size - 1" | bc`
pattern=`cat $NUC_FILE | cut -c 1-$size`
#echo "pattern = $pattern" > RESULTS/junk.tmp
size=`cat $NUC_FILE | tr '|' '\n' | sed s," ",, | cut -d ' ' -f 1 | sort | uniq | tr '\n' '_' | wc -c`
size=`echo "$size - 1" | bc`
nuclei=`cat $NUC_FILE | tr '|' '\n' | sed s," ",, | cut -d ' ' -f 1 | sort | uniq | tr '\n' '_' | cut -c 1-$size`
#echo "nuclei = $nuclei" >> RESULTS/junk.tmp
grep -E "$pattern" ./cs_all.in > RESULTS/cs.tmp
\mv -f RESULTS/cs.tmp "$NUC_FILE"

################################################################################
# Compute statistics (if necessary)
#
STAT_FILE="./MODELS/BMRB_${nuclei}_stats.out"
#echo $STAT_FILE;
if test ! -f $STAT_FILE; then
  $BMRB_STATS -bd "$BMRB_DIR" -i "$NUC_FILE" -o "$STAT_FILE" < ./BMRB_selected_sequences.txt 2> "$ERR_FILE"
fi

################################################################################
# Run RESCUE2
#
$RESCUE2 -cspd -af "$NUC_FILE" -sf "$STAT_FILE" < "$XML_FILE" > "$RES_FILE" 2> "$ERR_FILE"

################################################################################
#Clean File 
rm -f "$NUC_FILE"
#rm -f "$RES_FILE"
rm -f "$ERR_FILE"
rm -f "$EXP_FILE"
rm -f "$XML_FILE"

